<?php

require_once("ews/ExchangeServices.php");
require_once("pbx/pbx.php");
require_once("include.php");

class Test {
    const user = "report";
    const pw = "reporting";
    const email = "reporting@innovaphone.com";
}

$exchangeDb = get_exchange_db();
$query = "SELECT id FROM servers";
$result = $exchangeDb->run($query);
$row = pg_fetch_object($result);
/* @var $server ExchangeServer */ $server = new ExchangeServer();
if($server->read($row->id) === false) {
    die("Couldn't read server with id {$row->id}");
}
$server->ews->account = Test::user;
$server->ews->pw = Test::pw;
/* @var $ews ExchangeServices */ $ews = $server->ewsSoap();
if($ews === false) {
    die("Exchange Web Service connection failed: ".$server->error);
}
/* @var $version EWS_RequestServerVersion */ $version = new EWS_RequestServerVersion();
$version->Version = $server->ews->version;

$action = $_GET["action"];
if(!isset($action) || $action == "") exit;

switch($action) {
    case "delete":
        delete_items();
        break;
    case "add":
        add_item();
        break;
    case "check":
        check_items();
        break;
    case "change":
        change_item();
        break;
}

function add_item() {
    /* @var $ews ExchangeServices */ global $ews;
    /* @var $version EWS_RequestServerVersion */ global $version;
        
    $subject = $_GET["subject"];
    $running = isset($_GET["running"]);
    $showAs = $_GET["showas"];  // free, busy, tentative, away
    if(!isset($subject) || !isset($showAs)) die("subject and showas must be set!");
    $request = new EWS_CreateItemType();
    $request->MessageDisposition = EWS_CreateItemType::MessageDisposition_SendAndSaveCopy;
    $request->SendMeetingInvitations = EWS_CreateItemType::SendMeetingInvitations_SendToAllAndSaveCopy;
    
    $calItem = new EWS_CalendarItemType();
    /*$calItem->Body = new EWS_BodyType();
    $calItem->Body->BodyType = EWS_BodyType::BodyType_Text;*/
    $calItem->Subject = $subject;
    switch($showAs) {
        case "free":
            $calItem->LegacyFreeBusyStatus = EWS_CalendarItemType::LegacyFreeBusyStatus_Free;
            break;
        case "busy":
            $calItem->LegacyFreeBusyStatus = EWS_CalendarItemType::LegacyFreeBusyStatus_Busy;
            break;
        case "tentative":
            $calItem->LegacyFreeBusyStatus = EWS_CalendarItemType::LegacyFreeBusyStatus_Tentative;
            break;
        case "away":
            $calItem->LegacyFreeBusyStatus = EWS_CalendarItemType::LegacyFreeBusyStatus_OOF;
            break;
    }
    // "2002-05-30T09:00:00"
    $start = strtotime("+5 hour", time());
    if($running) {
        $start = strtotime("-5 hour", time());
    }
    $end = strtotime("+10 hour", time());
    $calItem->Start = date("Y-m-d\TH:i:s", $start);
    $calItem->End = date("Y-m-d\TH:i:s", $end);
    
    $folderId = new EWS_DistinguishedFolderIdType();
    $folderId->Id = EWS_DistinguishedFolderIdType::Id_calendar;
        
    $request->Items = new EWS_NonEmptyArrayOfAllItemsType();
    $request->Items->CalendarItem[] = $calItem;
    $request->SavedItemFolderId = new EWS_TargetFolderIdType();
    $request->SavedItemFolderId->DistinguishedFolderId = $folderId;
    
    //var_dump($calItem);
    try {
        $response = $ews->CreateItem($request, null, null, $version, null);
        /* @var $res EWS_ItemInfoResponseMessageType*/ $res = $response->ResponseMessages->CreateItemResponseMessage;
        /* @var $cal EWS_CalendarItemType */ $cal = $res->Items->CalendarItem;
        var_dump($response);
    }
    catch(Exception $e) {
        die("Creation of calendar item failed: ".$e->getMessage());
    }
}

function change_item() {
    /* @var $ews ExchangeServices */ global $ews;
    /* @var $version EWS_RequestServerVersion */ global $version;
    /* @var $server ExchangeServer */ global $server;
    
    $subject = $_GET["subject"];
    $subjectNew = $_GET["subjectnew"];
    if(!isset($subject) || !isset($subjectNew)) die("subject and subjectnew must be set!");
    $mailboxes = array();
    $mailBox = new EWS_MailboxData();
    // Identify the user mailbox to review for free/busy data.
    $emailAddress = new EWS_EmailAddress();
    $emailAddress->Address = Test::email;
    $emailAddress->Name = "";

    $mailBox->Email = $emailAddress;
    $mailBox->ExcludeConflicts = false;
    $mailBox->AttendeeType = EWS_MailboxData::AttendeeType_Organizer;
    $mailboxes[] = $mailBox;

    // Identify the time to compare free/busy information.
    $duration = new EWS_Duration();
    $duration->StartTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime());
    $duration->EndTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime() + $server->ews->availabilityTimespan * 60 * 60 );

    // Identify the options for comparing free/busy information.
    $fbViewOptions = new EWS_FreeBusyViewOptionsType();
    $fbViewOptions->TimeWindow = $duration;
    $fbViewOptions->RequestedView = EWS_FreeBusyViewOptionsType::RequestedView_Detailed;

    // Make the request.
    $request = new EWS_GetUserAvailabilityRequestType();

    // Set the time zone of the request (UTC!)
    $request->TimeZone = new EWS_SerializableTimeZone();
    $request->TimeZone->Bias = 0;
    $request->TimeZone->StandardTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->StandardTime->Bias = 0;
    $request->TimeZone->StandardTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->StandardTime->DayOrder = 1;
    $request->TimeZone->StandardTime->Month = 1;
    $request->TimeZone->StandardTime->Time = "00:00:00";
    $request->TimeZone->DaylightTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->DaylightTime->Bias = 0;
    $request->TimeZone->DaylightTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->DaylightTime->DayOrder = 5;
    $request->TimeZone->DaylightTime->Month = 12;
    $request->TimeZone->DaylightTime->Time = "23:59:59";

    // Add the mailboxes to the request.
    $request->MailboxDataArray = $mailboxes;

    // Add the view options to the request.
    $request->FreeBusyViewOptions = $fbViewOptions;

    /* @var $result EWS_GetUserAvailabilityResponseType*/$result = null;
    try
    {
        $result = $ews->GetUserAvailability($request, null, null, $version);
    }
    catch(Exception $e) {
        die("Getting user availability failed: ".$e->getMessage());
    }

    if($result->FreeBusyResponseArray != null && $result->FreeBusyResponseArray->FreeBusyResponse != null) {
        $freeBusyResponses = $result->FreeBusyResponseArray->FreeBusyResponse;
        if(!is_array($freeBusyResponses)) {
            $freeBusyResponses = array($freeBusyResponses);
        }
        foreach($freeBusyResponses as $index => /* @var $freeBusyResponse EWS_FreeBusyResponseType */ $freeBusyResponse) {
            $calendarEvents = array();
            if($freeBusyResponse->ResponseMessage->ResponseClass == EWS_ResponseMessageType::ResponseClass_Success) {
                if($freeBusyResponse->FreeBusyView && $freeBusyResponse->FreeBusyView->CalendarEventArray && $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent) {
                    $calendarEvents = $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent;
                    if(!is_array($calendarEvents)) {
                        $calendarEvents = array($calendarEvents);
                    }
                }
            }
            var_dump($calendarEvents);
            foreach($calendarEvents as /*@var $event EWS_CalendarEvent*/$event) {
                if($event->CalendarEventDetails->Subject == $subject) {
                    $convert = new EWS_ConvertIdType();
                    $convert->DestinationFormat = EWS_ConvertIdType::DestinationFormat_EwsId;
                    $convert->SourceIds = new EWS_NonEmptyArrayOfAlternateIdsType();
                    $altId = new EWS_AlternateIdType();
                    $altId->Id = $event->CalendarEventDetails->ID;
                    $altId->Format = EWS_AlternateIdType::Format_HexEntryId;
                    $altId->Mailbox = Test::email;
                    $convert->SourceIds->AlternateId[] = $altId;
                    try {
                        $response = $ews->ConvertId($convert, null, $version);
                    }
                    catch(Exception $e) {
                        die("Converting calendar ID failed with Exception: ".$e->getMessage());
                    }
                    /* @var $msg EWS_ConvertIdResponseMessageType*/ $msg = $response->ResponseMessages->ConvertIdResponseMessage;
                    if($msg->ResponseClass != EWS_ResponseMessageType::ResponseClass_Success) {
                        die("Converting calendar ID failed: {$msg->MessageText}");
                    }
                    elseif($msg->AlternateId->Id == "") {
                        die("Converting calendar ID failed: no ID returned");
                    }
                    $changeKey = new EWS_GetItemType();
                    $changeKey->ItemShape = new EWS_ItemResponseShapeType();
                    $changeKey->ItemShape->BaseShape = EWS_ItemResponseShapeType::BaseShape_IdOnly;
                    $calId = new EWS_ItemIdType();
                    $calId->Id = $msg->AlternateId->Id;
                    $changeKey->ItemIds = new EWS_NonEmptyArrayOfBaseItemIdsType();
                    $changeKey->ItemIds->ItemId[] = $calId;
                    try {
                        $response = $ews->GetItem($changeKey, null, null, $version);
                    }
                    catch(Exception $e) {
                        die("Retrieving change key failed with Exception: ".$e->getMessage());
                    }
                    var_dump($response);
                    /* @var $msg2 EWS_ItemInfoResponseMessageType */ $msg2 = $response->ResponseMessages->GetItemResponseMessage;
                    if($msg2->ResponseClass != EWS_ResponseMessageType::ResponseClass_Success) {
                        die("Retrieving change key was not successfull");
                    }
                    /* @var $oldCalItem EWS_CalendarItemType */ $oldCalItem = $msg2->Items->CalendarItem;
                    var_dump($oldCalItem);
                    
                    $update = new EWS_UpdateItemType();
                    $update->ConflictResolution = EWS_UpdateItemType::ConflictResolution_AlwaysOverwrite;
                    $update->MessageDisposition = EWS_UpdateItemType::MessageDisposition_SendAndSaveCopy;
                    $update->SendMeetingInvitationsOrCancellations = EWS_UpdateItemType::SendMeetingInvitationsOrCancellations_SendToChangedAndSaveCopy;
                    $folderId = new EWS_DistinguishedFolderIdType();
                    $folderId->Id = EWS_DistinguishedFolderIdType::Id_calendar;
                    $update->SavedItemFolderId = new EWS_TargetFolderIdType();
                    $update->SavedItemFolderId->DistinguishedFolderId = $folderId;
                    $update->ItemChanges = new EWS_NonEmptyArrayOfItemChangesType();
                    $item = new EWS_ItemChangeType();
                    $item->ItemId = new EWS_ItemIdType();
                    $item->ItemId->Id = $msg->AlternateId->Id;
                    $item->ItemId->ChangeKey = $oldCalItem->ItemId->ChangeKey;
                    $item->Updates = new EWS_NonEmptyArrayOfItemChangeDescriptionsType();
                    $change = new EWS_SetItemFieldType();
                    $path = new EWS_PathToUnindexedFieldType();
                    $path->FieldURI = EWS_PathToUnindexedFieldType::FieldURI_itemSubject;
                    $change->Path = $path;
                    $calItem = new EWS_CalendarItemType();
                    $calItem->Subject = $subjectNew;
                    $change->CalendarItem = $calItem;
                    $item->Updates->SetItemField = array();
                    $item->Updates->SetItemField[] = $change;
                    $update->ItemChanges->ItemChange = array();
                    $update->ItemChanges->ItemChange[] = $item;
                    try {
                        $result = $ews->UpdateItem($update, null, null, $version, null);
                    }
                    catch(Exception $e) {
                        die("Updating item failed with Exception: ".$e->getMessage());
                    }
                    var_dump($result);
                    return;
                }
            }
        }
    }
}

function delete_items() {
    /* @var $ews ExchangeServices */ global $ews;
    /* @var $version EWS_RequestServerVersion */ global $version;
    /* @var $server ExchangeServer */ global $server;
    
    $mailboxes = array();
    $mailBox = new EWS_MailboxData();
    // Identify the user mailbox to review for free/busy data.
    $emailAddress = new EWS_EmailAddress();
    $emailAddress->Address = Test::email;
    $emailAddress->Name = "";

    $mailBox->Email = $emailAddress;
    $mailBox->ExcludeConflicts = false;
    $mailBox->AttendeeType = EWS_MailboxData::AttendeeType_Organizer;
    $mailboxes[] = $mailBox;

    // Identify the time to compare free/busy information.
    $duration = new EWS_Duration();
    $duration->StartTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime());
    $duration->EndTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime() + $server->ews->availabilityTimespan * 60 * 60 );

    // Identify the options for comparing free/busy information.
    $fbViewOptions = new EWS_FreeBusyViewOptionsType();
    $fbViewOptions->TimeWindow = $duration;
    $fbViewOptions->RequestedView = EWS_FreeBusyViewOptionsType::RequestedView_Detailed;

    // Make the request.
    $request = new EWS_GetUserAvailabilityRequestType();

    // Set the time zone of the request (UTC!)
    $request->TimeZone = new EWS_SerializableTimeZone();
    $request->TimeZone->Bias = 0;
    $request->TimeZone->StandardTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->StandardTime->Bias = 0;
    $request->TimeZone->StandardTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->StandardTime->DayOrder = 1;
    $request->TimeZone->StandardTime->Month = 1;
    $request->TimeZone->StandardTime->Time = "00:00:00";
    $request->TimeZone->DaylightTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->DaylightTime->Bias = 0;
    $request->TimeZone->DaylightTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->DaylightTime->DayOrder = 5;
    $request->TimeZone->DaylightTime->Month = 12;
    $request->TimeZone->DaylightTime->Time = "23:59:59";

    // Add the mailboxes to the request.
    $request->MailboxDataArray = $mailboxes;

    // Add the view options to the request.
    $request->FreeBusyViewOptions = $fbViewOptions;

    /* @var $result EWS_GetUserAvailabilityResponseType*/$result = null;
    try
    {
        $result = $ews->GetUserAvailability($request, null, null, $version);
    }
    catch(Exception $e) {
        die("Getting user availability failed: ".$e->getMessage());
    }

    if($result->FreeBusyResponseArray != null && $result->FreeBusyResponseArray->FreeBusyResponse != null) {
        $freeBusyResponses = $result->FreeBusyResponseArray->FreeBusyResponse;
        if(!is_array($freeBusyResponses)) {
            $freeBusyResponses = array($freeBusyResponses);
        }
        foreach($freeBusyResponses as $index => /* @var $freeBusyResponse EWS_FreeBusyResponseType */ $freeBusyResponse) {
            $calendarEvents = array();
            if($freeBusyResponse->ResponseMessage->ResponseClass == EWS_ResponseMessageType::ResponseClass_Success) {
                if($freeBusyResponse->FreeBusyView && $freeBusyResponse->FreeBusyView->CalendarEventArray && $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent) {
                    $calendarEvents = $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent;
                    if(!is_array($calendarEvents)) {
                        $calendarEvents = array($calendarEvents);
                    }
                }
            }
            var_dump($calendarEvents);
            foreach($calendarEvents as /*@var $event EWS_CalendarEvent*/$event) {
                $convert = new EWS_ConvertIdType();
                $convert->DestinationFormat = EWS_ConvertIdType::DestinationFormat_EwsId;
                $convert->SourceIds = new EWS_NonEmptyArrayOfAlternateIdsType();
                $altId = new EWS_AlternateIdType();
                $altId->Id = $event->CalendarEventDetails->ID;
                $altId->Format = EWS_AlternateIdType::Format_HexEntryId;
                $altId->Mailbox = Test::email;
                $convert->SourceIds->AlternateId[] = $altId;
                try {
                    $response = $ews->ConvertId($convert, null, $version);
                }
                catch(Exception $e) {
                    die("Converting calendar ID failed with Exception: ".$e->getMessage());
                }
                $msg = $response->ResponseMessages->ConvertIdResponseMessage;
                if($msg->ResponseClass != EWS_ResponseMessageType::ResponseClass_Success) {
                    die("Converting calendar ID failed: {$msg->MessageText}");
                }
                elseif($msg->AlternateId->Id == "") {
                    die("Converting calendar ID failed: no ID returned");
                }
                $delete = new EWS_DeleteItemType();
                $delete->DeleteType = EWS_DeleteItemType::DeleteType_HardDelete;
                $calId = new EWS_ItemIdType();
                $calId->Id = $msg->AlternateId->Id;
                $delete->ItemIds = new EWS_NonEmptyArrayOfBaseItemIdsType();
                $delete->ItemIds->ItemId[] = $calId;
                $delete->SendMeetingCancellations = EWS_DeleteItemType::SendMeetingCancellations_SendToNone;
                try {
                    $result = $ews->DeleteItem($delete, null, null, $version);            
                    var_dump($result);
                }
                catch(Exception $e) {
                    die("Deleting calendar event failed: ".$e->getMessage());
                }
            }
        }
    }
}

function check_items() {
    /* @var $ews ExchangeServices */ global $ews;
    /* @var $version EWS_RequestServerVersion */ global $version;
    /* @var $server ExchangeServer */ global $server;
    
    $mailboxes = array();
    $mailBox = new EWS_MailboxData();
    // Identify the user mailbox to review for free/busy data.
    $emailAddress = new EWS_EmailAddress();
    $emailAddress->Address = Test::email;
    $emailAddress->Name = "";

    $mailBox->Email = $emailAddress;
    $mailBox->ExcludeConflicts = false;
    $mailBox->AttendeeType = EWS_MailboxData::AttendeeType_Organizer;
    $mailboxes[] = $mailBox;

    // Identify the time to compare free/busy information.
    $duration = new EWS_Duration();
    $duration->StartTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime());
    $duration->EndTime = gmdate('Y-m-d\TH:i:s.0000000\Z', gmmktime() + $server->ews->availabilityTimespan * 60 * 60 );

    // Identify the options for comparing free/busy information.
    $fbViewOptions = new EWS_FreeBusyViewOptionsType();
    $fbViewOptions->TimeWindow = $duration;
    $fbViewOptions->RequestedView = EWS_FreeBusyViewOptionsType::RequestedView_Detailed;

    // Make the request.
    $request = new EWS_GetUserAvailabilityRequestType();

    // Set the time zone of the request (UTC!)
    $request->TimeZone = new EWS_SerializableTimeZone();
    $request->TimeZone->Bias = 0;
    $request->TimeZone->StandardTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->StandardTime->Bias = 0;
    $request->TimeZone->StandardTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->StandardTime->DayOrder = 1;
    $request->TimeZone->StandardTime->Month = 1;
    $request->TimeZone->StandardTime->Time = "00:00:00";
    $request->TimeZone->DaylightTime = new EWS_SerializableTimeZoneTime();
    $request->TimeZone->DaylightTime->Bias = 0;
    $request->TimeZone->DaylightTime->DayOfWeek = EWS_SerializableTimeZoneTime::DayOfWeek_Sunday;
    $request->TimeZone->DaylightTime->DayOrder = 5;
    $request->TimeZone->DaylightTime->Month = 12;
    $request->TimeZone->DaylightTime->Time = "23:59:59";

    // Add the mailboxes to the request.
    $request->MailboxDataArray = $mailboxes;

    // Add the view options to the request.
    $request->FreeBusyViewOptions = $fbViewOptions;

    /* @var $result EWS_GetUserAvailabilityResponseType*/$result = null;
    try
    {
        $result = $ews->GetUserAvailability($request, null, null, $version);
    }
    catch(Exception $e) {
        die("Getting user availability failed: ".$e->getMessage());
    }

    $count = 0;
    echo "<items>\r\n";
    if($result->FreeBusyResponseArray != null && $result->FreeBusyResponseArray->FreeBusyResponse != null) {
        $freeBusyResponses = $result->FreeBusyResponseArray->FreeBusyResponse;
        if(!is_array($freeBusyResponses)) {
            $freeBusyResponses = array($freeBusyResponses);
        }
        foreach($freeBusyResponses as $index => /* @var $freeBusyResponse EWS_FreeBusyResponseType */ $freeBusyResponse) {
            $calendarEvents = array();
            if($freeBusyResponse->ResponseMessage->ResponseClass == EWS_ResponseMessageType::ResponseClass_Success) {
                if($freeBusyResponse->FreeBusyView && $freeBusyResponse->FreeBusyView->CalendarEventArray && $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent) {
                    $calendarEvents = $freeBusyResponse->FreeBusyView->CalendarEventArray->CalendarEvent;
                    if(!is_array($calendarEvents)) {
                        $calendarEvents = array($calendarEvents);
                    }
                }
            }
            $count += count($calendarEvents);
            foreach($calendarEvents as /*@var $event EWS_CalendarEvent*/$event) {
                echo "<item subject='{$event->CalendarEventDetails->Subject}' show-as='{$event->BusyType}'/>\r\n";
            }
        }
    }
    echo "</items>";
}
?>